#ifndef PSKlient_H
#define PSKlient_H

#include <Klient.h>
#include <KSGTDatei.h>
#include <Fortschritt.h>

using namespace Network;
using namespace Framework;

class PSKlient
{
private:
	int id;
	Klient *klient;
	CRITICAL_SECTION cs;
	char *schlssel;
	char schlsselLn;
	bool verbunden;
	Text *fehler;
	int ref;

public:
	// Konstruktor
	PSKlient();
	// Destruktor
	~PSKlient();
	// nicht constant
	void lock();
	void unlock();
	bool verbinde();
	bool verbinde( int port, const char *ip );
	KSGTDatei *getDateiGruppenListe();
	KSGTDatei *getDateiListe( int gruppe );
	__int64 getDateiGre( int gruppe, const char *pfad );
	bool downloadDatei( int gruppe, __int64 *start, const char *pfad, const char *zielPfad, FBalken *zFb, bool *abbruch, int maxbps );
	bool trenne( bool abmelden );
	// constant
	bool istVerbunden() const;
	bool istRegistriert() const;
	int getDownload() const;
	Text *zError() const;
	// Reference Counting
	PSKlient *getThis();
	PSKlient *release();
};

#endif